import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
public class Field extends World
{
    public int itemDimention;
    public Item selectedItem;//press and hold leftMouse button to select
    public Field()
    {    
        super(600, 400, 1); 
        itemDimention = 31;
        
        Inventory i = new Inventory(70,7,itemDimention);
        addObject(i, getWidth()/2,30);
        i.open();
        
    }
    public void act()
    {
        onLeftMouseRelease();
        if(Greenfoot.getMouseInfo()!= null && selectedItem != null)
        {
            selectedItem.setLocation(Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY());
        }
    }
    public void onLeftMouseRelease()
    {
        //FOR TESTING PURPOSES, FOR NOW just deselect
        if(leftMouseRelease())
        {
            //if released on build slot (to be implemented later), ignore other items also clicked on
            List<Item> list = getObjectsAt(Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY(), Item.class);
            list.remove(selectedItem);//do not include selectedItem in the list
            if(!list.isEmpty())
            {
                Item i = list.get(0);
                i.interactWith(selectedItem);
            }
            selectedItem = null;
        }
    }
    public boolean leftMousePress()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 1 && Greenfoot.mousePressed(null);
    }
    public boolean rightMousePress()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 3 && Greenfoot.mousePressed(null);
    }
    public boolean leftMouseRelease()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 1 && Greenfoot.mouseClicked(null);
    }
    public boolean rightMouseRelease()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 3 && Greenfoot.mouseClicked(null);
    }
}
